//
//  Hallo_TaxiAppDelegate.m
//  Hallo Taxi
//
//  Created by Holger Hinzberg on 02.04.11.
//  Copyright 2011 Cocoa-Coding. All rights reserved.
//

#import "Hallo_TaxiAppDelegate.h"

@implementation Hallo_TaxiAppDelegate

@synthesize window;
@synthesize checkIsHolidayTour;
@synthesize checkIsNightTour;
@synthesize checkHasLuggage;
@synthesize taxiFareLabel;
@synthesize sliderValueLabel;

- (void)awakeFromNib
{
    // Der Schieberegler ist bei Programmstart auf Position 1.
    // Das ist der Wert current im Interface Builder.
    [sliderValueLabel setIntValue:1];
    // Einen Fahrpreis gibt es noch nicht.
    [taxiFareLabel setStringValue:@""];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    fareCaluclator = [TaxiFareCalculator new];
}

- (IBAction)sliderDidMove:(id)sender
{
    // Ist der sender vom Type NSSlider?
    if([sender isKindOfClass: [NSSlider class]])
    {
        NSSlider *slider = sender;
        int value = [slider intValue];
        [sliderValueLabel setIntValue:value];   
            
        // Kilometerstand des FareCalculator übergeben.
        fareCaluclator.kilometer = value;
        // Rechnen
        double fare = [fareCaluclator calculateFare];
        // Ergebnis an Label-Steuerelement senden.
        [taxiFareLabel setDoubleValue:fare];
    }
}
- (IBAction)checkBoxDidChange:(id)sender
{
    // Hat schweres Gepäck?
    if( [checkHasLuggage state] == NSOnState)
    {
        fareCaluclator.hasLuggage = YES;
    }
    else {
        fareCaluclator.hasLuggage = NO;
    }
    
    // Ist es ein Feiertag?
    if( [checkIsHolidayTour state] == NSOnState)
    {
        fareCaluclator.isHolidayTour = YES;
    }
    else {
        fareCaluclator.isHolidayTour = NO;
    }   
    
    // Ist es eine Nachtfahrt?
    if( [checkIsNightTour state] == NSOnState)
    {
        fareCaluclator.isNightTour = YES;
    }
    else {
        fareCaluclator.isNightTour = NO;
    }          
    
    // Rechnen
    double fare = [fareCaluclator calculateFare];
    // Ergebnis an Label-Steuerelement senden.
    [taxiFareLabel setDoubleValue:fare];
}

- (void)dealloc
{
    [fareCaluclator release];
    [super dealloc];
}

@end
